# Template of Requirements table


This model is quite useful if the list of requirements isn't very long. The same list can be done quite conveniently with Excel, but it will soon lead to the complexity of documentation.
When one environment is used to gather relevant information, it is easier to link them to each other and the information stays up to date better.


## Customer & Business

**Customer Requirements** 


| Requirement ID | Description | Related feature |								
|:-:|:-:|:-:|
| CUSTOMER-REQ-0001 | eg.  As a user I want to login using my Facebook credentials to avoid any hassle. | [Feature template](template-feature.md) | 
| CUSTOMER-REQ-0002 | ... |||
| CUSTOMER-REQ-0003 | ... |||

**Business requirements**

| Requirement ID | Description | Related feature |									
|:-:|:-:|:-:|
| BUSINESS-REQ-0001 | eg.  Logging in to the service should be easy so that we can reach a wide user base = 35% of the target group | [Feature template](template-feature.md) | 
| BUSINESS-REQ-0002 |...||
| BUSINESS-REQ-0003 |...||

## Techical or Legal Constraints?

**Constraints and standards**

| Requirement ID |  Description | Related feature |
|:-:|:-:|:-:|
| CONSTRAINT-REQ-S00000 |  Login process must follow the AC5-2009 standard.  | [Feature template](template-feature.md) |
| CONSTRAINT-REQ-S00001 |...||
| CONSTRAINT-REQ-S00002 |...||

## Prodction environment / technical requirements



| Requirement ID | Description | Related feature |								
|:-:|:-:|:-:|
| SYSTEM-REQ-0001 | eg. Login services must have an independent verification system from a third party. | [Feature template](template-feature.md) |
| SYSTEM-REQ-0002 | eg.  The main parts of the service must be at least reduplicated N+1 | |
| SYSTEM-REQ-0003 |...||
| SYSTEM-REQ-0004 |...||


## Functional requirements

| Requirement ID | Description | Related feature |									
|:-:|:-:|:-:|
| FUNCTIONAL-REQ-C0001 | eg.  As a user (Customer profiles 1-4) I can login using Facebook-credentials | [Feature template](template-feature.md) |
| FUNCTIONAL-REQ-C0002 |...||
| FUNCTIONAL-REQ-C0003 |...||


## Non-functional requirements

**Security**

| Requirement ID |  Description | Related feature |									
|:-:|:-:|:-:|
| SECURITY-REQ-0001 | eg. At least level MD5 encryption must be used for the password, because it is required in standard XY112 | [Feature template](template-feature.md) |								
| SECURITY-REQ-0002 |...||
| SECURITY-REQ-0003 |...||


**Performance**

| Requirement ID | Description | Related feature |								
|:-:|:-:|:-:|
| PERFORMANCE-REQ-0000 | eg. At least 100 users must be able to login at the same time (100 request/s) | [Feature template](template-feature.md) |		
| PERFORMANCE-REQ-0001 |...||
| PERFORMANCE-REQ-0002 |...||



**Usability**

| Requirement ID |  Description | Related feature |							
|:-:|:-:|:-:|
| USABILITY-REQ-0000 |  eg.  | [Feature template](template-feature.md) | |	
| USABILITY-REQ-0001 |... ||
| USABILITY-REQ-0002 |... ||

**Safety**

| Requirement ID |  Description | Related feature |								
|:-:|:-:|:-:|
| SAFETY-REQ-0000 | eg.  No safety requirements can be assigned to this product  | [Feature template](template-feature.md)	|	
| SAFETY-REQ-0001 |...||	


## Mechanical requirements

| Requirement ID | Description | Related feature |									
|:-:|:-:|:-:|
| MECHANICAL-REQ-000 | eg. Size of installation board is  (WxLxT) 50 mm x 150 mm x 19mm | | 	
| MECHANICAL-REQ-001 |... || 	
| MECHANICAL-REQ-002 |...  || 	


